import teambot,network,prefer,time,sys
from colorama import init, Fore, Style
ENDF = Style.RESET_ALL

ROOT = "/home/khuxkm/code/auditbot/"

opts = prefer.Preferences(ROOT+"prefs.json")

VERBOSE = opts.get("verbose")
COLORS = {"*":"cyan","!":"yellow","X":"red"}
def say_log(s,p="*",c=None):
	if c is None:
		c = COLORS.get(p,None)
	c = getattr(Fore,c.upper())
	print(c+"[{}] {}".format(p,s)+ENDF)

bbj = network.BBJ(port=opts.get("port",7099))
say_log("Logging in with username {} and password {}...".format(opts.get("username"),opts.get("password")))
if not bbj.set_credentials(opts.get("username"),opts.get("password")):
	say_log("Incorrect details provided","X")
	sys.exit(1)
if not opts.get("thread_id"):
	say_log("Creating thread...")
	thread = bbj.thread_create(opts.get("title"),opts.get("text"))
	opts.set("thread_id",thread["thread_id"])
say_log("...and BBJ is all set up!")

trigger = lambda x: "{}: ".format(x)
log = lambda x,e: e[len(trigger(x)):]

class AuditBot(teambot.Handler,teambot.CommandHandlerMixin):
	def handle_command(self,target,nick,text):
		nick = nick.split("|")[0]
		if nick in opts.get("sudoers") and text.startswith(trigger(self.bot.bot_nick)):
			say_log("{} is auditing \"{}\"".format(nick,log(self.bot.bot_nick,text)))
			r = bbj.thread_reply(opts.get("thread_id"),opts.get("format").format(time.strftime("%Y-%m-%d %H:%M:%S"),nick,log(self.bot.bot_nick,text)))
			say_log(repr(r))

if __name__=="__main__":
	channels = "#sudoers".split()
	bot = teambot.TeamBot(channels,"auditor","localhost",chandler=AuditBot)
	say_log("Starting IRC bot...")
	bot.start()
